#version 150

in vec3 Position;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform float FogEnd;

out mat4 ProjInv;
out float isSky;
out float vertexDistance;
out float vertexID;

void main() {
    vertexID = gl_VertexID;
    vec3 Pos0 = Position;
    ProjInv = inverse(ProjMat * ModelViewMat);
    isSky = 0.0;
    vertexDistance = length((ModelViewMat * vec4(Position, 1.0)).xyz);

    if (abs(Pos0.y  - 16.0) < 0.004 && (length(Pos0.xz) <= 0.004 || abs(length(Pos0.xz) - 512.0) < 0.004)) {
        isSky = 1.0;

        if (length(Pos0.xz) > 1.0) {
            Pos0.y = -32.0;
        }

        Pos0.xyz *= 0.01;

        Pos0 = Pos0.xzy;
        Pos0.z *= -1;

        gl_Position = ProjMat * vec4(Pos0, 1.0);
    } else {
        gl_Position = ProjMat * ModelViewMat * vec4(Pos0, 1.0);
    }
}
